#ifndef GRILLESUDOKU_H
#define GRILLESUDOKU_H

#include <QWidget>
#include <QLineEdit>
#include <QVBoxLayout>
#include <QHBoxLayout>

class GrilleSudoku : public QWidget
{
	Q_OBJECT
private:
	int m[9][9];
	int m_save[9][9];
	int m_resultat[9][9];
	int m_debut[9][9];
	int status[9][9];

	int niveau;
	bool nbPossibles;
	bool delaiOK;

	bool jeu_termine, jeu_resolu;

	QLineEdit *mLine[9][9];

	void setMLine(int nb,int i,int j);

	bool testNbSolutions();

	QTimer *delai;
	QColor *genererColor, *aideColor, *resoluColor, *normalColor;
	QHBoxLayout *grille_layout;
    QVBoxLayout *layout;

    QGridLayout *grilleLayout;


	void genererSudoku();
	void resoudreRecursivement(int nb_a_resoudre, int nb_resolu);
	int nbSolutions(int nb_a_resoudre, int nb_resolu);
	int nbSolutions3(int nb_a_resoudre, int nb_resolu); //tests^^
	int nbSolutions2(int nb_a_resoudre, int nb_resolu, int i, int j); //a tester^^
	int nbCasesVides();

	void ligne(int* liste, int i); //renvoie la ligne
	void colonne(int* liste, int j); //renvoie la colonne
	void zone(int* liste, int i, int j); //renvoie la zone
	bool nEstPasDans(int* liste,int n); //teste si un nombre est dans une liste
	bool nombresPossibles(int* liste, int i, int j, int* n); //renvoie les nombres possibles d'une case

public:
	GrilleSudoku();
	~GrilleSudoku();

	void nouveau();
	bool generer();
	bool resoudre();
	void aide();
	void recommencer();
	bool tester();
	//void print();

    void load(const QString &nomDuFichier, bool nouveau=false);
    bool save(const QString &nomDuFichier, bool nouveau=false);
    bool saveHtml(const QString &nomDuFichier);

    bool estTermine();

	void setNiveau(int);
	int getNiveau();
	void setNombresPossibles(bool);
	bool getNombresPossibles();
	void setColors(QColor g, QColor a, QColor r, QColor n);
	void getColors(QColor *g, QColor *a, QColor *r, QColor *n);

	int nombreSolutions() {return nbSolutions3(nbCasesVides(), 0);}


	bool eventFilter(QObject*, QEvent*); //filtre les touches

public slots:
	void setNbPossibles();
	void delaiPasse();

};
#endif
