/************************
 * MainWindow.cpp		*
 * PETITJEAN Maxime		*
 * 09/04/2006			*
 ************************/
#include <QtGui>

#include "MainWindow.h"

MainWindow::MainWindow(QWidget *parent)
{
    //int i;
    tps=0;
    niveau = 2;
    jeu_termine = false;
    jeu_resolu = false;

    w = new QWidget;
    setCentralWidget(w);
    w->setSizePolicy(QSizePolicy::Expanding, QSizePolicy::Expanding);

    niveauLabel = new QLabel("Niveau : Moyen");

    genererColor = new QColor(255, 62, 36);
    aideColor = new QColor(41, 212, 255);
    resoluColor = new QColor(42, 255, 92);
    normalColor = new QColor(255, 255, 255);

	timer = new QTimer(this);
	connect(timer, SIGNAL(timeout()), this, SLOT(updateHorloge()));

	horloge = new QLCDNumber();
	horloge->setSegmentStyle(QLCDNumber::Filled);
	horloge->setNumDigits(8);
	horloge->display("00:00:00");


    b_generer = new QPushButton("&Gnrer",this);
    b_generer->setStatusTip(tr("Gnrer une nouvelle grille."));
    b_generer->setFixedSize(100,25);
    b_resoudre = new QPushButton("&Rsoudre",this);
    b_resoudre->setStatusTip(tr("Rsoudre la grille."));
    b_resoudre->setFixedSize(100,25);
    b_aide = new QPushButton("&Aide",this);
    b_aide->setStatusTip(tr("Donne un nombre."));
    b_aide->setFixedSize(100,25);
    b_quitter = new QPushButton("&Quitter");
    b_quitter->setStatusTip(tr("Quitter SudoKU."));
    b_quitter->setFixedSize(100,25);

    b_pause = new QPushButton("&Pause");
	b_pause->setStatusTip(tr("Mettre le jeu en pause."));
    b_pause->setFixedSize(100,25);

    /*for(i=0;i<81;i++)
    {
        status[i/9][i%9]=0;
        m_line[i] = new QLineEdit();
        m_line[i]->setObjectName(tr("case%1").arg(i));
        m_line[i]->installEventFilter(this);
        m_line[i]->setAlignment(Qt::AlignCenter);
        m_line[i]->setMaximumSize(30,30);
        m_line[i]->setMinimumSize(30,30);

        QRegExp rx("[1-9]");
		m_line[i]->setValidator(new QRegExpValidator(rx, this)); //permet de ne pouvoir saisir que des nombre de 1  9

    	connect(m_line[i], SIGNAL(editingFinished()),  this, SLOT(setNbPossibles()));
    }*/

    connect(b_generer, SIGNAL(clicked()),  this, SLOT(slotGenerer()));
    connect(b_resoudre, SIGNAL(clicked()),  this, SLOT(slotResoudre()));
    connect(b_aide, SIGNAL(clicked()),  this, SLOT(slotAide()));
    connect(b_pause, SIGNAL(clicked()),  this, SLOT(pause()));
    connect(b_quitter, SIGNAL(clicked()), qApp, SLOT(quit()));




    menu_boutons = new QVBoxLayout;
    menu_boutons->addWidget(b_generer);
    menu_boutons->addWidget(b_resoudre);
    menu_boutons->addWidget(b_aide);
    menu_boutons->addWidget(niveauLabel);
    menu_boutons->addStretch(1);
    menu_boutons->addWidget(b_pause);
    menu_boutons->addWidget(horloge);
    menu_boutons->addWidget(b_quitter);



    gr = new GrilleSudoku();

    /*grille_layout = new QVBoxLayout[9];

    for(i=0;i<9;i++)
    {
        grille_layout[i].addStretch(1);
        for(j=0;j<9;j++)
        {
            grille_layout[i].addWidget(m_line[i*9+j]);
            if (j%3==2 && j!=8) grille_layout[i].addSpacing(15);
        }
        grille_layout[i].addStretch(1);
    }*/


    layout = new QHBoxLayout;
    layout->addLayout(menu_boutons);
    layout->addStretch(1);
    /*for(i=0;i<9;i++)
    {
        layout->addLayout(&grille_layout[i]);
        if (i%3==2 && i!=8) layout->addSpacing(15);
    }*/

    layout->addWidget(gr);

    layout->addStretch(1);
    w->setLayout(layout);

    setWindowIcon ( QIcon("./icone.png") );

    createActions();
    createMenus();

	setStatusBar( new QStatusBar());

    //setMinimumSize(500, 400);

	slotGenerer();
}

MainWindow::~MainWindow()
{
      /*int i;

      delete generationBar;
      delete b_generer;
      delete b_resoudre;
      delete b_aide;
      delete b_quitter;

      for (i=0;i<81;i++)
      {
          delete m_line[i];
      }

      delete menu_boutons;
      delete []grille_layout;

      delete layout;*/
}



void MainWindow::slotGenerer()
{
	if(gr->generer())
	{
		tps=0;
		timer->start(1000);
		horloge->show();
	}
}

void MainWindow::slotResoudre()
{
	if(gr->resoudre()) timer->stop();
}

void MainWindow::slotAide()
{
	gr->aide();
}

void MainWindow::nouveau()
{
	NouveauWidget *newW = new NouveauWidget();
	newW->show();
}
void MainWindow::open()
{

	QString str = QFileDialog::getOpenFileName(this,"Ouvrir une grille","","Fichiers SudoKU (*.sku)");
	if (str!=QString::null)
	{
		gr->load(str);
	}
	tps=0;
	timer->start(1000);
	horloge->show();

}
void MainWindow::save()
{
	QString str = QFileDialog::getSaveFileName(this,"Enregistrer la grille","","Fichiers SudoKU (*.sku)");
	if (str!=QString::null)
	{
		if (str.mid(str.length()-4,4)!=".sku") str +=".sku";
		gr->save(str);
	}
}



void MainWindow::saveHtml()
{
	QString str = QFileDialog::getSaveFileName(this,"Exporter la grille","","Fichiers Html (*.html)");
	if (str!=QString::null)
	{
		if (str.mid(str.length()-5,5)!=".html") str +=".html";
		gr->saveHtml(str);
	}
}
void MainWindow::print()
{

}
void MainWindow::pause()
{
	if(b_pause->text()=="&Pause")
	{
		timer->stop();
		gr->hide();
		b_generer->setEnabled(false);
		b_resoudre->setEnabled(false);
		b_aide->setEnabled(false);
		genererAct->setEnabled(false);
		resoudreAct->setEnabled(false);
		aideAct->setEnabled(false);
		recommencerAct->setEnabled(false);
		b_pause->setText("&Continuer");
		pauseAct->setText("&Continuer");
	}
	else
	{
		gr->show();
		b_generer->setEnabled(true);
		b_resoudre->setEnabled(true);
		b_aide->setEnabled(true);
		genererAct->setEnabled(true);
		resoudreAct->setEnabled(true);
		aideAct->setEnabled(true);
		recommencerAct->setEnabled(true);
		b_pause->setText("&Pause");
		pauseAct->setText("&Pause");
		timer->start();
	}

}
void MainWindow::recommencer()
{
	gr->recommencer();
	tps=0;
	timer->start(1000);
	horloge->show();
}
void MainWindow::setNiveauFacile()
{
     niveau = 1;
     updateNiveauLabel();
     gr->setNiveau(1);
}
void MainWindow::setNiveauMoyen()
{
     niveau = 2;
     updateNiveauLabel();
     gr->setNiveau(2);
}
void MainWindow::setNiveauDifficile()
{
     niveau = 3;
     updateNiveauLabel();
     gr->setNiveau(3);
}
void MainWindow::about()
{
    QMessageBox::information(this, tr("A propos de SudoKU"), tr("SudoKU par PETITJEAN Maxime. \nVersion 0.5, juin 2006"));
}



void MainWindow::createActions()
{

    /**********Fichier********/

    newAct = new QAction(tr("&Nouveau"), this);
    newAct->setShortcut(tr("Ctrl+N"));
    newAct->setStatusTip(tr("Nouvelle grille."));
    connect(newAct, SIGNAL(triggered()), this, SLOT(nouveau()));

    openAct = new QAction(tr("&Ouvrir..."), this);
    openAct->setShortcut(tr("Ctrl+O"));
    openAct->setStatusTip(tr("Ouvrir une grille."));
    connect(openAct, SIGNAL(triggered()), this, SLOT(open()));

    saveAct = new QAction(tr("&Sauvegarder"), this);
    saveAct->setShortcut(tr("Ctrl+S"));
    saveAct->setStatusTip(tr("Sauvegarder la grille."));
    connect(saveAct, SIGNAL(triggered()), this, SLOT(save()));

    saveHtmlAct = new QAction(tr("&Exporter"), this);
	saveHtmlAct->setShortcut(tr("Ctrl+E"));
	saveHtmlAct->setStatusTip(tr("Exporter la grille au format html."));
    connect(saveHtmlAct, SIGNAL(triggered()), this, SLOT(saveHtml()));

    printAct = new QAction(tr("&Imprimer..."), this);
    printAct->setShortcut(tr("Ctrl+P"));
    printAct->setStatusTip(tr("Imprimer la grille."));
    printAct->setEnabled(false);
    connect(printAct, SIGNAL(triggered()), this, SLOT(print()));

    exitAct = new QAction(tr("&Quitter"), this);
    exitAct->setShortcut(tr("Ctrl+Q"));
    exitAct->setStatusTip(tr("Quitter SudoKu."));
    connect(exitAct, SIGNAL(triggered()), qApp, SLOT(quit()));

    /**********Edition********/

    genererAct = new QAction(tr("&Gnrer"), this);
    genererAct->setShortcut(tr("Ctrl+G"));
    genererAct->setStatusTip(tr("Gnrer une nouvelle grille."));
    connect(genererAct, SIGNAL(triggered()), this, SLOT(slotGenerer()));

    resoudreAct = new QAction(tr("&Rsoudre"), this);
    resoudreAct->setShortcut(tr("Ctrl+R"));
    resoudreAct->setStatusTip(tr("Rsoudre la grille."));
    connect(resoudreAct, SIGNAL(triggered()), this, SLOT(slotResoudre()));

    aideAct = new QAction(tr("&Aide"), this);
	aideAct->setShortcut(tr("Ctrl+H"));
	aideAct->setStatusTip(tr("Donne un nombre."));
    connect(aideAct, SIGNAL(triggered()), this, SLOT(slotAide()));

    pauseAct = new QAction(tr("&Pause"), this);
	pauseAct->setShortcut(tr("Ctrl+W"));
	pauseAct->setStatusTip(tr("Met le jeu en pause."));
    connect(pauseAct, SIGNAL(triggered()), this, SLOT(pause()));

	recommencerAct = new QAction(tr("&Recommencer"), this);
	recommencerAct->setShortcut(tr("F2"));
	recommencerAct->setStatusTip(tr("Recommencer cette grille."));
    connect(recommencerAct, SIGNAL(triggered()), this, SLOT(recommencer()));

    /**********Option********/

    niveauFacileAct = new QAction(tr("&Facile"), this);
    niveauFacileAct->setCheckable(true);
    niveauFacileAct->setShortcut(tr("Ctrl+1"));
    niveauFacileAct->setStatusTip(tr("Niveau facile : la rsolution est simple, parfait pour dbuter !"));
    connect(niveauFacileAct, SIGNAL(triggered()), this, SLOT(setNiveauFacile()));

    niveauMoyenAct = new QAction(tr("&Moyen"), this);
    niveauMoyenAct->setCheckable(true);
    niveauMoyenAct->setShortcut(tr("Ctrl+2"));
    niveauMoyenAct->setStatusTip(tr("Niveau moyen : rsolution facile, pas de grosses difficults."));
    connect(niveauMoyenAct, SIGNAL(triggered()), this, SLOT(setNiveauMoyen()));

    niveauDifficileAct = new QAction(tr("&Difficile"), this);
    niveauDifficileAct->setCheckable(true);
    niveauDifficileAct->setShortcut(tr("Ctrl+3"));
    niveauDifficileAct->setStatusTip(tr("Niveau difficile : Rflexion obligatoire ! La gnration peut prendre plusieurs secondes."));
    connect(niveauDifficileAct, SIGNAL(triggered()), this, SLOT(setNiveauDifficile()));

    niveauGroup = new QActionGroup(this);
    niveauGroup->addAction(niveauFacileAct);
    niveauGroup->addAction(niveauMoyenAct);
    niveauGroup->addAction(niveauDifficileAct);
    niveauMoyenAct->setChecked(true);

    voirNbPossiblesAct = new QAction(tr("&Nombres Possibles"), this);
	voirNbPossiblesAct->setCheckable(true);
	voirNbPossiblesAct->setStatusTip(tr("Affiche les nombres possibles de la case."));
	connect(voirNbPossiblesAct, SIGNAL(triggered()), this, SLOT(setNbPossibles()));

	optionsAct = new QAction(tr("&Options"), this);
	optionsAct->setStatusTip(tr("Options du jeu."));
	connect(optionsAct, SIGNAL(triggered()), this, SLOT(openOptionsWidget()));


    /**********?********/

    aboutAct = new QAction(tr("&A propos"), this);
    aboutAct->setStatusTip(tr("A propos de SudoKU"));
    connect(aboutAct, SIGNAL(triggered()), this, SLOT(about()));

}

void MainWindow::createMenus()
{
    fileMenu = menuBar()->addMenu(tr("&Fichier"));
    fileMenu->addAction(newAct);
    fileMenu->addAction(openAct);
    fileMenu->addAction(saveAct);
    fileMenu->addAction(saveHtmlAct);
    fileMenu->addAction(printAct);
    fileMenu->addSeparator();
    fileMenu->addAction(exitAct);

    editMenu = menuBar()->addMenu(tr("&Edition"));
    editMenu->addAction(genererAct);
    editMenu->addAction(resoudreAct);
    editMenu->addAction(aideAct);
    editMenu->addAction(pauseAct);
    editMenu->addAction(recommencerAct);

    optionMenu = menuBar()->addMenu(tr("&Option"));
    niveauMenu = optionMenu->addMenu(tr("&Niveau"));
    niveauMenu->addAction(niveauFacileAct);
    niveauMenu->addAction(niveauMoyenAct);
    niveauMenu->addAction(niveauDifficileAct);
    optionMenu->addAction(voirNbPossiblesAct);
    optionMenu->addAction(optionsAct);

    helpMenu = menuBar()->addMenu(tr("?"));
    helpMenu->addAction(aboutAct);
}
void MainWindow::updateNiveauLabel()
{
    switch (niveau)
     {
            case 1 : niveauLabel->setText("Niveau : Facile");; break;
            case 2 : niveauLabel->setText("Niveau : Moyen");; break;
            case 3 : niveauLabel->setText("Niveau : Difficile");; break;
     }
}

void MainWindow::setNbPossibles()
{
	gr->setNombresPossibles(voirNbPossiblesAct->isChecked());
	//statusBar()->showMessage(gr->focusWidget()->statusTip());
}
void MainWindow::estTermine()
{

}
void MainWindow::updateHorloge()
{
	int heures, minutes, secondes;

	tps++;

	QString str;

	if (!gr->estTermine())
	{

		heures = tps/3600;
		minutes = (tps-heures*3600)/60;
		secondes = tps-heures*3600-minutes*60;

		if (secondes==60)
		{
			secondes = 0;
			minutes++;
			if (minutes == 60)
			{
				heures++;
			}
		}
		str = "";
		if (heures<10) str +="0";
		str += tr("%1:").arg(heures);
		if (minutes<10) str +="0";
		str += tr("%1:").arg(minutes);
		if (secondes<10) str +="0";
		str += tr("%1").arg(secondes);
		horloge->display(str);
	}
	else
	{
		timer->stop();
	}

}
void MainWindow::openOptionsWidget()
{
	OptionWidget *owidget = new OptionWidget(genererColor, resoluColor, aideColor, normalColor);
	if (owidget->exec()==0)
	{
		gr->setColors(*genererColor, *aideColor, *resoluColor, *normalColor);
	}
	delete owidget;
}
