/************************
 * MainWindow.h			*
 * PETITJEAN Maxime		*
 * 09/04/2006			*
 ************************/

#ifndef MAINWINDOW_H

#define MAINWINDOW_H
#include <QMainWindow>

    class QAction;
    class QActionGroup;
    class QLabel;
    class QMenu;

#include <QString>
#include <QPushButton>
#include <QLineEdit>
#include <QVBoxLayout>
#include <QWidget>
#include <QApplication>
#include <QMessageBox>
#include <QRect>
#include <QProgressBar>
#include <QSpacerItem>
#include <QLCDNumber>

//#include "grille.h"
#include "NouveauWidget.h"
#include "OptionWidget.h"
#include "GrilleSudoku.h"

class MainWindow : public QMainWindow
{
      Q_OBJECT
public:
    MainWindow(QWidget *parent = 0);
    ~MainWindow();

    void updateNiveauLabel();
    void estTermine();

public slots:
    void slotGenerer();
    void slotResoudre();
    void slotAide();

    void nouveau();
    void open();
    void save();
    void saveHtml();
    void print();
    void pause();
    void recommencer();
    void setNiveauFacile();
    void setNiveauMoyen();
    void setNiveauDifficile();
    void setNbPossibles();
    void updateHorloge();
    void openOptionsWidget();

    void about();

private:
    void createActions();
    void createMenus();

	bool jeu_termine, jeu_resolu;
    int niveau;
    int tps;
    //grille g;
    //int status[9][9];   //0 : blanc
    					//1 : rouge
    					//2 : vert
    					//3 : bleu
    //QLineEdit *m_line[81];
    QPushButton *b_generer, *b_resoudre, *b_aide, *b_pause, *b_quitter;
    QVBoxLayout *menu_boutons, *grille_layout;
    QHBoxLayout *layout;
    QLabel *niveauLabel;
    QWidget *w;
    QTimer *timer;
    QColor *genererColor, *aideColor, *resoluColor, *normalColor;

    QMenu *fileMenu;
    QMenu *editMenu;
    QMenu *niveauMenu;
    QMenu *optionMenu;
    QMenu *helpMenu;

    QActionGroup *niveauGroup;
    QAction *newAct;
    QAction *openAct;
    QAction *saveAct;
    QAction *saveHtmlAct;
    QAction *printAct;
    QAction *exitAct;

    QAction *genererAct;
    QAction *resoudreAct;
    QAction *aideAct;
    QAction *pauseAct;
    QAction *recommencerAct;

    QAction *aboutAct;
    QAction *niveauFacileAct;
    QAction *niveauMoyenAct;
    QAction *niveauDifficileAct;
    QAction *voirNbPossiblesAct;
    QAction *optionsAct;


    GrilleSudoku *gr;

    QLCDNumber *horloge;

};
#endif
