/************************
 * NouveauWidget.cpp	*
 * PETITJEAN Maxime		*
 * 09/04/2006			*
 ************************/
#include <QtGui>

#include "NouveauWidget.h"

NouveauWidget::NouveauWidget(QWidget *parent)
{
	b_new = new QPushButton("&Nouveau",this);
    b_new->setFixedSize(100,25);
	b_open = new QPushButton("&Ouvrir",this);
    b_open->setFixedSize(100,25);
    b_save = new QPushButton("&Sauvegarder",this);
    b_save->setFixedSize(100,25);
    b_ok = new QPushButton("Ok",this);
    b_ok->setFixedSize(100,25);
    b_tester = new QPushButton("&Tester",this);
    b_tester->setFixedSize(100,25);

    gr = new GrilleSudoku();

	connect(b_new, SIGNAL(clicked()),  this, SLOT(slotNew()));
    connect(b_save, SIGNAL(clicked()),  this, SLOT(slotSave()));
    connect(b_open, SIGNAL(clicked()),  this, SLOT(slotOpen()));
    connect(b_tester, SIGNAL(clicked()),  this, SLOT(slotTester()));
    connect(b_ok, SIGNAL(clicked()), this, SLOT(close()));

    menu_boutons = new QVBoxLayout;
    menu_boutons->addStretch(1);
    menu_boutons->addWidget(b_new);
    menu_boutons->addWidget(b_open);
    menu_boutons->addWidget(b_save);
    menu_boutons->addWidget(b_tester);
    menu_boutons->addWidget(b_ok);

    layout = new QHBoxLayout;
    layout->addLayout(menu_boutons);
    layout->addStretch(1);
    layout->addWidget(gr);
    layout->addStretch(1);
    setLayout(layout);
    setWindowTitle("Crez votre propre grille !");
    setWindowIcon ( QIcon("./icone.png") );
}

void NouveauWidget::slotSave()
{
	if(gr->tester())
	{
		QString str = QFileDialog::getSaveFileName(this,"Enregistrer la grille","","Fichiers SudoKU (*.sku)");
		if (str!=QString::null)
		{
			if (str.mid(str.length()-4,4)!=".sku") str +=".sku";
			gr->save(str,true);
		}
	}
	else
	{
		QMessageBox::warning(this, "Vrification","Votre grille est incorrecte !");
	}
}
void NouveauWidget::slotOpen()
{
	QString str = QFileDialog::getOpenFileName(this,"Ouvrir une grille","","Fichiers SudoKU (*.sku)");
	if (str!=QString::null)
	{
		gr->load(str,true);
	}

}

void NouveauWidget::slotTester()
{
	if( gr->tester() )
	{
		QMessageBox::information(this, "Vrification","Votre grille est correcte.");
	}
	else
	{
		QMessageBox::warning(this, "Vrification","Votre grille est incorrecte !");
	}
}

void NouveauWidget::slotNew()
{
	gr->nouveau();
}
