/************************
 * OptionWidget.cpp		*
 * PETITJEAN Maxime		*
 * 09/04/2006			*
 ************************/
#include <QtGui>

#include "OptionWidget.h"

OptionWidget::OptionWidget(QColor* gColor, QColor* rColor, QColor* aColor, QColor* nColor)
{

	genererColorSave = gColor;
	resoluColorSave = rColor;
	aideColorSave = aColor;
	normalColorSave = nColor;

	genererColor = new QColor (*gColor);
	resoluColor = new QColor (*rColor);
	aideColor = new QColor (*aColor);
	normalColor = new QColor (*nColor);

	label = new QLabel("Selectionnez vos couleurs : ");

	b_ok = new QPushButton("OK");
	b_annuler = new QPushButton("Annuler");
	connect(b_ok, SIGNAL(clicked()),  this, SLOT(slotOK()));
    connect(b_annuler, SIGNAL(clicked()), this, SLOT(slotAnnuler()));

	QPixmap pixmapBoutons(16,16);
	pixmapBoutons.fill(*genererColor);
	b_genererColor = new QPushButton(QIcon(pixmapBoutons),"Couleur de gnration");
	connect(b_genererColor, SIGNAL(clicked()),  this, SLOT(genererColorDialog()));

	pixmapBoutons.fill(*resoluColor);
	b_resoluColor = new QPushButton(QIcon(pixmapBoutons),"Couleur de rsolution");
	connect(b_resoluColor, SIGNAL(clicked()),  this, SLOT(resoluColorDialog()));

	pixmapBoutons.fill(*aideColor);
	b_aideColor = new QPushButton(QIcon(pixmapBoutons),"Couleur d'aide");
	connect(b_aideColor, SIGNAL(clicked()),  this, SLOT(aideColorDialog()));

	pixmapBoutons.fill(*normalColor);
	b_normalColor = new QPushButton(QIcon(pixmapBoutons),"Couleur de base");
	connect(b_normalColor, SIGNAL(clicked()),  this, SLOT(normalColorDialog()));



	menu_boutons = new QHBoxLayout();
	menu_boutons->addWidget(b_ok);
	menu_boutons->addWidget(b_annuler);
	option_layout = new QVBoxLayout();
	option_layout->addWidget(label);
	option_layout->addWidget(b_genererColor);
	option_layout->addWidget(b_resoluColor);
	option_layout->addWidget(b_aideColor);
	option_layout->addWidget(b_normalColor);

    layout = new QVBoxLayout();
    layout->addLayout(option_layout);
    layout->addLayout(menu_boutons);

    setLayout(layout);

    setWindowTitle("Options");
    setWindowIcon ( QIcon("./icone.png") );

    show();

}

QColor* OptionWidget::getGenererColor()
{
	return genererColor;
}
QColor* OptionWidget::getResoluColor()
{
	return resoluColor;
}
QColor* OptionWidget::getAideColor()
{
	return aideColor;
}
QColor* OptionWidget::getNormalColor()
{
	return normalColor;
}

void OptionWidget::genererColorDialog()
{
	QPixmap pixmapBoutons(16,16);
	QColor color = QColorDialog::getColor ( *genererColor );
	if( color.isValid() )
		genererColor->setRgb(color.rgb());
	pixmapBoutons.fill(*genererColor);
	b_genererColor->setIcon( QIcon(pixmapBoutons));
}
void OptionWidget::resoluColorDialog()
{
	QPixmap pixmapBoutons(16,16);
	QColor color = QColorDialog::getColor ( *resoluColor );
	if( color.isValid() )
		resoluColor->setRgb(color.rgb());
	pixmapBoutons.fill(*resoluColor);
	b_resoluColor->setIcon( QIcon(pixmapBoutons));
}
void OptionWidget::aideColorDialog()
{
	QPixmap pixmapBoutons(16,16);
	QColor color = QColorDialog::getColor ( *aideColor );
	if( color.isValid() )
		aideColor->setRgb(color.rgb());
	pixmapBoutons.fill(*aideColor);
	b_aideColor->setIcon( QIcon(pixmapBoutons));
}
void OptionWidget::normalColorDialog()
{
	QPixmap pixmapBoutons(16,16);
	QColor color = QColorDialog::getColor ( *normalColor );
	if( color.isValid() )
		normalColor->setRgb(color.rgb());
	pixmapBoutons.fill(*normalColor);
	b_normalColor->setIcon( QIcon(pixmapBoutons));
}
void OptionWidget::slotOK()
{
	genererColorSave->setRgb(genererColor->rgb());
	resoluColorSave->setRgb(resoluColor->rgb());
	aideColorSave->setRgb(aideColor->rgb());
	normalColorSave->setRgb(normalColor->rgb());
	done(0);
}
void OptionWidget::slotAnnuler()
{
	done(1);
}
