/************************
 * grille.cpp			*
 * PETITJEAN Maxime		*
 * 09/04/2006			*
 ************************/
#include <iostream>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include "grille.h"

using namespace std;

grille::grille()
{
	int i,j;
	for (i=0;i<9;i++)
		for (j=0;j<9;j++)
		{
			m[i][j]=0;
			m_resultat[i][j]=0;
		}
}

void grille::ligne(int* liste, int i)
{
	int j;
	for (j=0;j<9;j++)
		liste[j]=m[i][j];
}

void grille::colonne(int* liste, int j)
{
	int i;
	for (i=0;i<9;i++)
		liste[i]=m[i][j];
}
void grille::zone(int* liste, int i,int j)
{
	int k;
	i=i/3*3;
	j=j/3*3;
	for (k=0;k<9;k++)
		liste[k]=m[i+k%3][j+k/3];
}
bool grille::nEstPasDans(int* liste,int n)
{
	int k;
	for (k=0;k<9;k++)
	{
		if(liste[k]==n) return false;
	}
	return true;
}
bool grille::nombrePossible(int* liste, int i, int j)
{
	int l1[9],l2[9],l3[9];
	int k,indice=0;
	for(k=0;k<9;k++)
	{
		l1[k]=0;
		l2[k]=0;
		l3[k]=0;
		liste[k]=0;
	}
	if(m[i][j]!=0) return false;
	ligne(l1,i);
	colonne(l2,j);
	zone(l3,i,j);
	for(k=1;k<10;k++)
	{
		if (nEstPasDans(l1,k) && nEstPasDans(l2,k) && nEstPasDans(l3,k))
		{
			liste[indice++]=k;
		}
	}
	return true;
}
int grille::nbCasesVides()
{
	int i,j,nb=0;
	for (i=0;i<9;i++)
		for (j=0;j<9;j++)
			if(m[i][j]==0) nb++;
	return nb;
}
void grille::remp_m(char *str)
{
	int i,j;
	for(i=0;i<9;i++)
	{
		for(j=0;j<9;j++)
		{
			m[i][j]=str[i*9+j]-'0';
		}
	}
}
int grille::getM(int i,int j)
{
    return m[i][j];
}
int grille::getM_Resultat(int i,int j)
{
    return m_resultat[i][j];
}
void grille::setM(int nb, int i,int j)
{
    m[i][j]=nb;
}

bool grille::set_m(char *str)
{
	if (strlen(str)!=81) return false;
	remp_m(str);
	return true;
}
void grille::remp_cases_poss()
{
	int i,j,k;
	for(i=0;i<9;i++)
	{
		for(j=0;j<9;j++)
		{
			if (!nombrePossible(cases_poss[i][j], i, j))
			{
				for(k=0;k<9;k++)
				{
					cases_poss[i][j][k]=0;
				}
			}
		}
	}
}
/*void grille::affiche_cases_poss(int i, int j)
{
	int k;
	for(k=0;k<9;k++)
	{
		if(cases_poss[i][j][k]!=0)
		{
			cout<<cases_poss[i][j][k];
		}
		cout<<endl;
	}
}*/

bool grille::resoudre_cases_directes()
{
	int nbcases=nbCasesVides();
	int nbcases2=0;
	int i, j, k, k2, nb_cases_possibles,nb=0;
	while (nbcases!=nbcases2)
	{
		nbcases2=nbcases;
		for (i=0;i<9;i++)
		{
			for (j=0;j<9;j++)
			{
				nb_cases_possibles=0;
				for (k=0;k<9;k++)
				{
					if(cases_poss[i][j][k]!=0)
					{
						nb_cases_possibles++;
						nb=cases_poss[i][j][k];
					}
				}
				if(nb_cases_possibles==1)
				{
					m[i][j]=nb;
					for(k=0;k<9;k++)
					{
						for(k2=0;k2<9;k2++)
						{
							if (cases_poss[i][k][k2]==nb)
							{
								cases_poss[i][k][k2]=0;
							}
							if (cases_poss[k][j][k2]==nb)
							{
								cases_poss[k][j][k2]=0;
							}
							if (cases_poss[i/3*3+k%3][j/3*3+k/3][k2]==nb)
							{
								cases_poss[i/3*3+k%3][j/3*3+k/3][k2]=0;
							}
						}
					}
				}
			}
		}
		nbcases=nbCasesVides();
		//cout<<nbcases<<" "<<nbcases2<<endl;
	}
	return (nbcases==0);
}

void grille::resoudre_recursivement(int nb_a_resoudre, int nb_resolu, bool &fin)
{
	int i,j,k;
	int liste[9];
	bool solution=true;

	if (!fin)
	{
        if (nb_a_resoudre>nb_resolu)
    	{
    		for (i=0;i<9 && solution;i++)
    		{
    			for (j=0;j<9 && solution;j++)
    			{
    				if (m[i][j]==0)
    				{
    					if (!nombrePossible(liste, i, j))
    					{
    						for(k=0;k<9;k++)
    						{
    							liste[k]=0;
    						}
    					}
    					solution=false;
    					for (k=0;k<9;k++)
    					{
    						if (liste[k]!=0)
    						{
    							m[i][j]=liste[k];
    							resoudre_recursivement(nb_a_resoudre,nb_resolu+1,fin);
    							m[i][j]=0;
    							//i=0;j=0;
    						}
    					}
    				}
    			}
    		}
    	}
    	else
    	{
    		fin=true;
            for (i=0;i<9;i++)
    		{
    			for (j=0;j<9;j++)
    			{
    				m_resultat[i][j]=m[i][j];
    			}
    		}
    	}
     }
}

int grille::nb_solutions(int nb_a_resoudre, int nb_resolu)
{
	int i=0,j=0,k,nb=0;
	int liste[9];
	bool solution=true;

	if (nb_a_resoudre>nb_resolu)
	{
		for (i=0;i<9 && solution;i++)
		{
			for (j=0;j<9 && solution;j++)
			{
				if (m[i][j]==0)
				{
					if (nombrePossible(liste, i, j))
					{
    					solution=false;
    					for (k=0;k<9;k++)
    					{
    						if (liste[k]!=0)
    						{
    							m[i][j]=liste[k];
    							nb += nb_solutions(nb_a_resoudre,nb_resolu+1);
    							m[i][j]=0;
    						}
    					}
                    }
				}
			}
		}
	}
	else
	{
		nb++;
	}
	return nb;
}

int grille::nb_solutions_generation(int nb_a_resoudre, int nb_resolu, bool &fin)
{
	int i=0,j=0,k,nb=0;
	int liste[9];
	bool solution=true;
	if (!fin)
	{
    	if (nb_a_resoudre>nb_resolu)
    	{
    		for (i=0;i<9 && solution;i++)
    		{
    			for (j=0;j<9 && solution;j++)
    			{
    				if (m[i][j]==0)
    				{
    					if (nombrePossible(liste, i, j))
    					{
        					solution=false;
        					for (k=0;k<9;k++)
        					{
        						if (liste[k]!=0)
        						{
        							m[i][j]=liste[k];
        							nb += nb_solutions_generation(nb_a_resoudre,nb_resolu+1,fin);
        							m[i][j]=0;
        						}
        					}
                        }
    				}
    			}
    		}
    	}
    	else
    	{
    		nb++;
    		if (nb==2) fin=true;
    	}
     }
	return nb;
}



/*void grille::generer_sudoku()
{
	int liste[9];
	int liste2[9];
	int nb[3];
	int i,j,k,n,ii,jj,kk;
	bool echec=true;
	srand(time(NULL));
	while (echec)
	{
		for(i=0;i<9;i++) for(j=0;j<9;j++)m[i][j]=0;
		echec=false;
		for(i=0;i<9 && !echec;i++)
		{
			for(j=0;j<9 && !echec;j++)
			{
				for(k=0;k<9;k++) liste[k]=k+1;
				n=0;
				for(k=0;k<9;k++)
				{
					nb[0]=m[i][k]; //ligne
					nb[1]=m[k][j]; //colonne
					nb[2]=m[ (i/3)*3 + k/3 ][ (j/3)*3 + k%3 ]; //case
					for(kk=0;kk<3;kk++)
					{
						if(nb[kk]!=0)
						{
							//on enlve les nombres dj utiliss
							if(liste[nb[kk]-1]!=0)n++;
							liste[nb[kk]-1]=0;
						}
					}
				}
				if(n>8) echec=true; //si tous les nombres sont utiliss : chec
				if(!echec)
				{
					//tirage alatoire d'un nombre possible
					for(k=0,ii=0;k<9;k++) if(liste[k]!=0) liste2[ii++]=liste[k];
					m[i][j]=liste2[rand()%ii];
				}
			}
		}
	}
}*/



/*void grille::generer_sudoku()
{
	int i,j,k;
	int nb_cases_vides, nb_de_solutions=0;
	int liste[9];
	for (i=0;i<9;i++)
	{
		for (j=0;j<9;j++)
		{
			m_resultat[i][j]=m[i][j];
			m[i][j]=0;
		}
	}

	srand(time(NULL));

	do
	{
		//cout<<"|";
		i=rand()%9;
		j=rand()%9;
		if (m[i][j]==0)
		{
			if (!nombrePossible(liste, i, j))
			{
				for(k=0;k<9;k++)
				{
					liste[k]=0;
				}
			}
			do
			{
				k=rand()%9;
			}while(liste[k]==0);
			m[i][j]=liste[k];
		}
		nb_cases_vides = nbCasesVides();
		if (nb_cases_vides<60)
		{
			nb_de_solutions = nb_solutions(nb_cases_vides,0);
			if (nb_de_solutions==0) cout<<"generation echouee !"<<endl;
		}
	}while (nb_cases_vides>59 || nb_de_solutions>1);
	cout<<endl;
	for (i=0;i<9;i++)
	{
		for (j=0;j<9;j++)
		{
			int temp;
			temp=m[i][j];
			m[i][j]=m_resultat[i][j];
			m_resultat[i][j]=temp;
		}
	}
}

void grille::generer_sudoku2()
{
	int i,j,k,k2;
	int ligne1, ligne2;
	//int nb_cases_vides, nb_de_solutions=0;
	int liste1[9], liste2[9];
	for (i=0;i<9;i++)
	{
		for (j=0;j<9;j++)
		{
			m_resultat[i][j]=m[i][j];
			m[i][j]=(j+i*3+(i/3)%3)%9+1;
			cout<<m[i][j];
		}
		cout<<endl;
	}

	for(k=0;k<10;k++)
	{
		for(k2=0;k2<3;k2++)
		{
			ligne1=rand()%3+k2*3;
			ligne2=rand()%3+k2*3;
			ligne(liste1,ligne1);
			ligne(liste2,ligne2);
			for(j=0;j<9;j++)
			{
				m[ligne1][j]=liste2[j];
				m[ligne2][j]=liste1[j];
			}
		}
		for(k2=0;k2<3;k2++)
		{
			ligne1=rand()%3+k2*3;
			ligne2=rand()%3+k2*3;
			colonne(liste1,ligne1);
			colonne(liste2,ligne2);
			for(j=0;j<9;j++)
			{
				m[j][ligne1]=liste2[j];
				m[j][ligne2]=liste1[j];
			}
		}
	}

	cout<<endl;
	for (i=0;i<9;i++)
	{
		for (j=0;j<9;j++)
		{
			cout<<m[i][j];

			int temp;
			temp=m[i][j];
			m[i][j]=m_resultat[i][j];
			m_resultat[i][j]=temp;
		}
		cout<<endl;
	}
}*/

void grille::generer_sudoku3()
{
	int listes[2][9];
	int i,j,k,n,i3,j3,k2;
	bool echec=true,fin=false;

	srand(time(NULL));

	for (i=0;i<9;i++)
	{
		for (j=0;j<9;j++)
		{
			m_resultat[i][j]=m[i][j];
			m[i][j]=0;
		}
	}

	while (echec)
	{
		for(i=0;i<9;i++)
			for(j=0;j<9;j++)
				m[i][j]=0;

		echec=false;
		for(i=0;i<9 && !echec;i++)
		{
			for(j=0;j<9;j++)
			{
				for(k=0;k<9;k++) listes[0][k]=k+1;
				n=0;
				for(k=0;k<9;k++)
				{
					if(m[i][k])
					{
						if(listes[0][m[i][k]-1])n++;
						listes[0][m[i][k]-1]=0;
					}
					if(m[k][j])
					{
						if(listes[0][m[k][j]-1])n++;
						listes[0][m[k][j]-1]=0;
					}
				}

				for(i3=3*(i/3) ; i3<3*(i/3)+3 ; i3++)
				{
					for(j3=3*(j/3) ; j3<3*(j/3)+3 ; j3++)
					{
						if(m[i3][j3])
						{
							if(listes[0][m[i3][j3]-1])n++;
							listes[0][m[i3][j3]-1]=0;
						}
					}
				}
				if(n>8)
				{
					echec=true;
					break;
				}

				for(k=0,k2=0;k<9;k++)
				{
					if(listes[0][k])
					{
						listes[1][k2]=listes[0][k];
						k2++;
					}
				}
				m[i][j]=listes[1][rand()%k2];
			}
		}
	}

	for(k=0;k<80;k++)
	{
		//cout<<"|";
		i=rand()%9;
		j=rand()%9;
		if (m[i][j]!=0)
		{
			n=m[i][j];
			m[i][j]=0;
			if (nb_solutions_generation(nbCasesVides(),0,fin)>1)
				m[i][j]=n;
		}
	}

	for (i=0;i<9;i++)
	{
		for (j=0;j<9;j++)
		{
            if (m[i][j]!=0)
    		{
    			n=m[i][j];
    			m[i][j]=0;
    			if (nb_solutions_generation(nbCasesVides(),0,fin)>1)
    				m[i][j]=n;
    		}
        }
    }

	//cout<<endl;


	for (i=0;i<9;i++)
	{
		for (j=0;j<9;j++)
		{
			int temp;
			temp=m[i][j];
			m[i][j]=m_resultat[i][j];
			m_resultat[i][j]=temp;
		}
	}
}

void grille::generer_sudoku4()
{
	int listes[2][9];
	int i,j,k,n,i3,j3,k2;
	bool echec=true;

	srand(time(NULL));

	for (i=0;i<9;i++)
	{
		for (j=0;j<9;j++)
		{
			m_resultat[i][j]=m[i][j];
			m[i][j]=0;
		}
	}

	while (echec)
	{
		for(i=0;i<9;i++)
			for(j=0;j<9;j++)
				m[i][j]=0;

		echec=false;
		for(i=0;i<9 && !echec;i++)
		{
			for(j=0;j<9;j++)
			{
				for(k=0;k<9;k++) listes[0][k]=k+1;
				n=0;
				for(k=0;k<9;k++)
				{
					if(m[i][k])
					{
						if(listes[0][m[i][k]-1])n++;
						listes[0][m[i][k]-1]=0;
					}
					if(m[k][j])
					{
						if(listes[0][m[k][j]-1])n++;
						listes[0][m[k][j]-1]=0;
					}
				}

				for(i3=3*(i/3) ; i3<3*(i/3)+3 ; i3++)
				{
					for(j3=3*(j/3) ; j3<3*(j/3)+3 ; j3++)
					{
						if(m[i3][j3])
						{
							if(listes[0][m[i3][j3]-1])n++;
							listes[0][m[i3][j3]-1]=0;
						}
					}
				}
				if(n>8)
				{
					echec=true;
					break;
				}

				for(k=0,k2=0;k<9;k++)
				{
					if(listes[0][k])
					{
						listes[1][k2]=listes[0][k];
						k2++;
					}
				}
				m[i][j]=listes[1][rand()%k2];
			}
		}
	}
	for (i=0;i<9;i++)
	{
		for (j=0;j<9;j++)
		{
			int temp;
			temp=m[i][j];
			m[i][j]=m_resultat[i][j];
			m_resultat[i][j]=temp;
		}
	}
}

void grille::copie_resultat_to_m()
{
	int i,j;
	for (i=0;i<9;i++)
	{
		for (j=0;j<9;j++)
		{
			m[i][j]=m_resultat[i][j];
		}
	}
}
void grille::save_resultat()
{
	int i,j;
	char buffer[3];
	FILE *f;
	f=fopen("resultat.txt","w");
	if (f)
	{
		for(i=0;i<9;i++)
		{
			if(i%3==0)
			{
				//cout<<" ------- ------- -------"<<endl;
				fputs(" ------- ------- -------\n",f);
			}
			for(j=0;j<9;j++)
			{
				if (j%3==0) //cout<<"| ";
					fputs("| ",f);
				if (m_resultat[i][j]==0) //cout<<". ";
					fputs(". ",f);
				else
				{
					//cout<<m_resultat[i][j]<<" ";
					sprintf(buffer,"%d ",m_resultat[i][j]);
					fputs(buffer,f);
				}
			}
			//cout<<"| "<<endl;
			fputs("| \n",f);
		}
		//cout<<" ------- ------- -------"<<endl;
		fputs(" ------- ------- -------\n",f);
		fclose(f);
	}
}
